wa_racers/database/models.py
import datetime

import sqlalchemy

from . import Base
from .utils import UUID, get_uuid

__all__ = ["Racer"]


class Racer(Base):
	"""A racer."""

	__tablename__ = "racers"

	id = sqlalchemy.Column(
		UUID,
		primary_key=True,
		default=get_uuid
	)

	number = sqlalchemy.Column(
		sqlalchemy.Integer,
		nullable=False
	)

	name = sqlalchemy.Column(
		sqlalchemy.String(128),
		nullable=False
	)

	time = sqlalchemy.Column(
		sqlalchemy.Interval,
		nullable=False
	)

wa_racers/__init__.py
import json
import os
import typing

import flask
import flask_babel
import sqlalchemy.orm

__all__ = ["create_app"]


def create_app() -> flask.Flask:
	"""Creates a pre-configured :class:`Flask <flask.Flask>` app.

	If the ``CONFIG_LOCATION`` environment variable is set, loads the JSON config
	file located where it describes. Otherwise, attempts to load the current
	working directory's ``config.json`` as a fallback.

	:returns: The app.
	"""

	app = flask.Flask(__name__)

	with app.app_context():
		app.logger.info("Setting up app")

		app.logger.debug("Loading config file")

		app.config.from_file(
			os.environ.get(
				"CONFIG_LOCATION",
				os.path.join(
					os.getcwd(),
					"config.json"
				)
			),
			load=json.load
		)

		app.logger.debug("Creating engine")

		sa_engine = sqlalchemy.create_engine(app.config["DATABASE_URI"])

		app.sa_session_class = sqlalchemy.orm.scoped_session(
			sqlalchemy.orm.sessionmaker(
				bind=sa_engine
			)
		)

		app.logger.debug("Setting up extensions")

		babel = flask_babel.Babel(app)

		@app.before_request
		def before_request() -> None:
			"""TODO: doc"""

			flask.g.sa_session = flask.current_app.sa_session_class()

		@app.teardown_request
		def teardown_request(
			exception: typing.Union[None, Exception]
		) -> None:
			"""Attempts to commit :attr:`flask.g.sa_session` and rolls it back if
			any exception is raised during the process. The exception is then
			logged.

			:param exception: The exception that occurred in the prior request,
				if there was any.
			"""

			if "sa_session" in flask.g:
				# "Clean" the session
				try:
					flask.g.sa_session.commit()
				except Exception as commit_exception:
					flask.g.sa_session.rollback()

					flask.current_app.logger.error(
						"Exception %s raised during the request teardown session commit: %s",
						commit_exception.__class__.__name__,
						(
							commit_exception
							if hasattr(commit_exception, "__str__")
							else "no details"
						)
					)

				flask.current_app.sa_session_class.remove()

		from .views import racer_blueprint

		for blueprint in (racer_blueprint,):
			app.logger.debug(
				"Registering blueprint: %s",
				blueprint
			)

			app.register_blueprint(blueprint)

		@app.cli.command("reflect")
		def reflect() -> None:
			"""Reflects all models to the app's database."""

			from .database import Base

			Base.metadata.create_all(bind=sa_engine)

		return app

wa_racers/database/__init__.py
import sqlalchemy.orm

Base = sqlalchemy.orm.declarative_base()

from .utils import UUID, get_uuid
from .models import Racer

__all__ = [
	"UUID",
	"Racer",
	"get_uuid"
]

wa_racers/views/__init__.py
from .racer import racer_blueprint

__all__ = ["racer_blueprint"]

wa_racers/views/racer.py
from __future__ import annotations

import datetime
import hashlib
import http.client
import io
import typing
import uuid

import flask
import flask_babel
import flask_wtf
import sqlalchemy
import werkzeug.exceptions
import wtforms
import wtforms.validators

from .. import database

__all__ = [
	"RacerCreationEditForm",
	"add",
	"delete",
	"edit",
	"list_",
	"view",
	"racer_blueprint"
]


racer_blueprint = flask.Blueprint(
	"racer",
	__name__,
	url_prefix="/racers"
)


class RacerCreationEditForm(flask_wtf.FlaskForm):
	number = wtforms.fields.IntegerField(
		flask_babel.lazy_gettext("Number"),
		validators=[
			wtforms.validators.InputRequired(),
			wtforms.validators.NumberRange(min=1, max=2**31)
		]
	)

	name = wtforms.fields.StringField(
		flask_babel.lazy_gettext("Name"),
		validators=[
			wtforms.validators.InputRequired(),
			wtforms.validators.Length(min=1, max=128)
		]
	)

	time = wtforms.fields.IntegerField(
		flask_babel.lazy_gettext("Amount of seconds"),
		validators=[
			wtforms.validators.InputRequired(),
			wtforms.validators.NumberRange(min=1, max=2**31)
		]
	)


@racer_blueprint.route("/")
def list_() -> typing.Tuple[flask.Response, int]:
	order_by = flask.request.args.get("order-by", "number")
	order_type = flask.request.args.get("order-type", "desc")

	if (
		order_by not in ("number", "name", "time") or
		order_type not in ("asc", "desc")
	):
		raise werkzeug.exceptions.BadRequest

	racers = flask.g.sa_session.execute(
		sqlalchemy.select(database.Racer).
		order_by(
			getattr(sqlalchemy, order_type)(
				getattr(database.Racer, order_by)
			)
		)
	).scalars().all()

	return flask.render_template(
		"racer_list.html",
		racers=racers,
		order_by=order_by,
		order_type=order_type
	), http.client.OK


@racer_blueprint.route("/<uuid:id_>")
def view(id_: uuid.UUID) -> typing.Tuple[flask.Response, int]:
	racer = flask.g.sa_session.get(
		database.Racer,
		id_
	)

	if racer is None:
		raise werkzeug.exceptions.NotFound

	return flask.render_template(
		"racer_view.html",
		racer=racer
	), http.client.OK


@racer_blueprint.route("/add", methods=["GET", "POST"])
def add()  -> typing.Tuple[flask.Response, int]:
	form = RacerCreationEditForm()
	
	if form.validate_on_submit():
		flask.g.sa_session.add(
			database.Racer(
				number=form.number.data,
				name=form.name.data,
				time=datetime.timedelta(seconds=form.time.data)
			)
		)

		flask.g.sa_session.commit()

		return flask.redirect(flask.url_for("racer.list_"))

	return flask.render_template(
		"racer_add.html",
		form=form
	), http.client.OK


@racer_blueprint.route("/delete/<uuid:id_>")
def delete(id_: uuid.UUID) -> typing.Tuple[flask.Response, int]:
	racer = flask.g.sa_session.get(
		database.Racer,
		id_
	)

	if racer is None:
		raise werkzeug.exceptions.NotFound

	flask.g.sa_session.delete(racer)
	flask.g.sa_session.commit()

	return flask.redirect(flask.url_for("racer.list_"))


@racer_blueprint.route("/edit/<uuid:id_>", methods=["GET", "POST"])
def edit(id_: uuid.UUID) -> typing.Tuple[flask.Response, int]:
	racer = flask.g.sa_session.get(
		database.Racer,
		id_
	)

	if racer is None:
		raise werkzeug.exceptions.NotFound

	form = RacerCreationEditForm()
	
	if form.validate_on_submit():
		racer.number = form.number.data
		racer.name = form.name.data
		racer.time = datetime.timedelta(seconds=form.time.data)

		return flask.redirect(flask.url_for("racer.view", id_=racer.id))

	return flask.render_template(
		"racer_edit.html",
		racer=racer,
		form=form
	), http.client.OK

wa_racers/templates/base.html
<!DOCTYPE html>
<html>
	<head>
		<title>{% block current_page %}{% endblock %}</title>
		<meta charset="utf-8">
		<link rel="stylesheet" href="{{ url_for('static', filename='simple.css') }}">
	</head>
	<body>
		{% block content %}{% endblock %}
	</body>
</html>

wa_racers/templates/racer_add.html
{% extends 'base.html' %}

{% block current_page %}{{ gettext("Add a racer") }}{% endblock %}

{% block content %}<header>
	<h1>{{ gettext("Add a racer") }}</h1>
</header>
<main>
	<form method="POST">
		{{ form.hidden_tag() }}
		
		<div>
			{{ form.number(placeholder=form.number.label.text) }}
		</div>
		
		<div>
			{{ form.name(placeholder=form.name.label.text) }}
		</div>
		
		<div>
			{{ form.time(placeholder=form.time.label.text) }}
		</div>
		
		<input type="submit" value="{{ gettext('Add racer') }}">
	</form>
</main>{% endblock %}

wa_racers/templates/racer_edit.html
{% extends 'base.html' %}

{% block current_page %}{{ gettext("Edit racer %s").format(racer.number) }}{% endblock %}

{% block content %}<header>
	<h1>{{ gettext("Edit racer %s").format(racer.number) }}</h1>
</header>
<main>
	<form method="POST">
		{{ form.hidden_tag() }}
		
		<div>
			{{ form.number(placeholder=form.number.label.text, value=racer.number) }}
		</div>
		
		<div>
			{{ form.name(placeholder=form.name.label.text, value=racer.name) }}
		</div>
		
		<div>
			{{ form.time(placeholder=form.time.label.text, value=racer.time.total_seconds()|int) }}
		</div>
		
		<input type="submit" value="{{ gettext('Update racer') }}">
	</form>
</main>{% endblock %}

wa_racers/templates/racer_list.html
{% extends 'base.html' %}

{% block current_page %}{{ gettext("Racers") }}{% endblock %}

{% block content %}<header>
	<h1>{{ gettext("Racers") }}</h1>
</header>
<main>
	<a href="{{ url_for('racer.add') }}">{{ gettext("Add a racer") }}</a>

	<table>
		<tr>
			<th>{{ gettext("Number") }}</th>
			<th>{{ gettext("Name") }}</th>
			<th>{{ gettext("Time") }}</th>
		</tr>
		{% for racer in racers %}
			<tr>
				<td>
					<a href="{{ url_for('racer.view', id_=racer.id) }}">{{ racer.number }}</a>
				</td>
				<td>{{ racer.name }}</td>
				<td>{{ racer.time }}</td>
			</tr>
		{% endfor %}
	</table>
	
	<form method="GET">
		<b>{{ gettext("Sort") }}</b>

		<hr>

		<select name="order-by">
			<option value="number" {% if order_by == 'number' %}selected{% endif %}>{{ gettext("Number") }}</option>
			<option value="name" {% if order_by == 'name' %}selected{% endif %}>{{ gettext("Name") }}</option>
			<option value="time" {% if order_by == 'time' %}selected{% endif %}>{{ gettext("Time") }}</option>
		</select>

		<select name="order-type">
			<option value="asc" {% if order_type == 'asc' %}selected{% endif %}>{{ gettext("Ascending") }}</option>
			<option value="desc" {% if order_type == 'desc' %}selected{% endif %}>{{ gettext("Descending") }}</option>
		</select>

		<input type="submit" value="Sort, without JS!">
	</form>
</main>{% endblock %}

wa_racers/templates/racer_view.html
{% extends 'base.html' %}

{% block current_page %}{{ racer.name }}{% endblock %}

{% block content %}<header>
	<h1>{{ racer.name }}</h1>
</header>
<main>
	<a href="{{ url_for('racer.list_') }}">{{ gettext("Back to listing") }}</a>

	<section>
		<p>
			{{ gettext("Number: ") }}{{ racer.number }}<br>
			{{ gettext("Time: ") }}{{ racer.time }}
		</p>

		<section>
			<a href="{{ url_for('racer.delete', id_=racer.id) }}">{{ gettext("Delete this racer") }}</a>
			{{ gettext(" or ") }}
			<a href="{{ url_for('racer.edit', id_=racer.id) }}">{{ gettext("Update information") }}</a>
		</section>
	</section>
</main>{% endblock %}